
#include "Neuron.h"

Neuron::~Neuron() {
    if(this->activation_function_parameters){
        delete [] this->activation_function_parameters;
        this->activation_function_parameters = nullptr;
    }
}

void Neuron::adjust_potential(double input_signal) {
    this->potential += input_signal;
}

double Neuron::get_potential() {
    return this->potential;
}

void Neuron::set_potential(double value) {
    this->potential = value;
}

double Neuron::get_state() {
    return this->state;
}

void Neuron::set_state(double value) {
    this->state = value;
}

int Neuron::activation_function_get_n_parameters(){
    return this->n_activation_function_parameters;
}

void Neuron::activation_function_adjust_parameter(int param_idx, double value) {
    this->activation_function_parameters[param_idx] += value;
}

void Neuron::activation_function_set_parameter(int param_idx, double value) {
    this->activation_function_parameters[param_idx] = value;
}

double Neuron::activation_function_get_parameter(int param_idx) {
    return this->activation_function_parameters[param_idx];
}
